<?php
// These functions are common to all WSN scripts

function securityimagevalue()
{
 global $settings;
 $semirand = md5(substr(time(), 0, 6) . $settings->wsncodes); //value will change every 3 hours or so
 $value = strtolower(substr($semirand, 0, 4));
 $value = str_replace('o', 'q', $value); // avoid confusion over o vs 0
 // letters only, no numbers
 $value = str_replace('0', 'x', $value);
 $value = str_replace('1', 'z', $value);
 $value = str_replace('2', 's', $value);
 $value = str_replace('3', 'k', $value);
 $value = str_replace('4', 't', $value);
 $value = str_replace('5', 'm', $value); 
 $value = str_replace('6', 'n', $value);
 $value = str_replace('7', 'j', $value);
 $value = str_replace('8', 'y', $value);
 $value = str_replace('9', 'v', $value);
 return $value;
}

function OutputPhpDocument($doc)
{
 // want to do something with the page before final output? the full page is in $doc
 global $inadmindir, $leaveencoded, $justreplace;
 if (!$leaveencoded)
 {
  if ($inadmindir)
  {
   $doc = str_replace('[IFADMIN../]', '../', decodeit($doc));
   $doc = str_replace('[IFADMINadmin/]', '', decodeit($doc));
  }
  else
  {
   $doc = str_replace('[IFADMIN../]', '', decodeit($doc));
   $doc = str_replace('[IFADMINadmin/]', 'admin/', decodeit($doc));
  }

 }
 if ($justreplace)
   return $doc;
 else
   finaloutput($doc);
}

function texttoascii($text)
{
 $chars = str_split($text);
 for ($x=0; $x<sizeof($chars); $x++)
 {
  $ascii .= ord($chars[$x]) .' | ';
 }
 return $ascii;
}

function asciitotext($ascii)
{
 $chars = explode(' | ', $ascii);
 for ($x=0; $x<sizeof($chars); $x++)
 {
  $text .= chr($chars[$x]);
 }
 return $text;
}

function parsemessage($message)
{
 global $settings;
 // convert carrige returns to html line breaks
 $message = str_replace("\n", '<br>', $message);

 // apply censor/replacements
 $censorlist = explode('|||', $settings->censor);
 $num = sizeof($censorlist);
 for ($x=0; $x<$num; $x++)
 {
  $thiscensor = explode('[,]', $censorlist[$x]);
  $original = $thiscensor[0];
  $replacement = $thiscensor[1];
  if ($original != '') $message = str_replace($original, $replacement, $message);
 }

 // do WSN codes specified by admin
 $codelist = explode('|||', $settings->wsncodes);
 $num = sizeof($codelist);
 for ($p=0; $p<$num; $p++)
 {
  $thiscode = explode('[,]', $codelist[$p]);
  $original = $thiscode[0];
  $originalclose = $thiscode[1];
  $replacement = $thiscode[2];
  $replacementclose = $thiscode[3];
  $description = $thiscode[4];
  $format = $thiscode[5];
  if ($original != '')
  {
   if ($format == 'param')
   {
    $pattern = "{ORIGINAL}(.*?){ORIGINALCLOSE}";   
	$pattern = str_replace('{ORIGINAL}', $original, $pattern);
	if (strstr($pattern, '{PARAM}')) $paramtype = true;
	$pattern = str_replace('{PARAM}', '(.*?)', $pattern);
	$pattern = str_replace('{ORIGINALCLOSE}', $originalclose, $pattern);
    $pattern = str_replace('[', '\[', $pattern);
    $pattern = str_replace(']', '\]', $pattern);
    $pattern = str_replace('/', '\/', $pattern);
	$pattern = '/'. $pattern .'/i';	
    $changeto = "{REPLACEMENT}$2{REPLACEMENTCLOSE}";	
	$changeto = str_replace('{REPLACEMENT}', $replacement, $changeto);
	$changeto = str_replace('{REPLACEMENTCLOSE}', $replacementclose, $changeto);	
	if ($paramtype) 
	{
	 $changeto = str_replace('{PARAM}', '$1', $changeto);
	 $changeto = str_replace('{CONTENT}', '$2', $changeto);		
	}
	else
		 $changeto = str_replace('{CONTENT}', '$1', $changeto);		
	$message = preg_replace($pattern, $changeto, $message);
   }
   else
   {
    $pattern = "{ORIGINAL}(.*?){ORIGINALCLOSE}";   
    $pattern = str_replace('{ORIGINAL}', $original, $pattern);
	if (strstr($pattern, '{PARAM}')) $paramtype = true;	
	$pattern = str_replace('{PARAM}', '(.*?)', $pattern);	
    $pattern = str_replace('{ORIGINALCLOSE}', $originalclose, $pattern);
    $pattern = str_replace('[', '\[', $pattern);
    $pattern = str_replace(']', '\]', $pattern);
    $pattern = str_replace('/', '\/', $pattern);
	$pattern = '/'. $pattern .'/i';
	if ($paramtype) 
	{
	 $changeto = str_replace('{PARAM}', '$1', $changeto);
	 $changeto = str_replace('{CONTENT}', '$2', $changeto);		
     $changeto = "{REPLACEMENT}$2{REPLACEMENTCLOSE}";		 
	}
	else
      $changeto = "{REPLACEMENT}$1{REPLACEMENTCLOSE}";	
    $changeto = str_replace('{REPLACEMENT}', $replacement, $changeto);
    $changeto = str_replace('{REPLACEMENTCLOSE}', $replacementclose, $changeto);	
    $changeto = str_replace('{CONTENT}', '$1', $changeto);
    $message = preg_replace($pattern, $changeto, $message);   
   }
  }
 }
 
 // do smilies
 $codelist = explode('|||', $settings->smilies);
 $num = sizeof($codelist);
 for ($c=0; $c<$num; $c++)
 {
  $thiscode = explode(',', $codelist[$c]);
  $original = $thiscode[0];
  $replacement = $thiscode[1];
  $message = str_replace($original, $replacement, $message);
 }

 $message = preg_replace("/( [\w]+:\/\/[\w-?&;#~=\.\/\@]+[\w\/])/i",
"<a href=\"$1\" target=\"_blank\">$1</a>", 
$message); //make all URLs into links but try not to dupicate
 
 return str_replace('\\', '\\\\', $message); 
}

function sendtosite($url)
{
 $fd = @fopen($url, 'rb');
 @fclose ($fd);
 return true;
}

function extension($file)
{
 $groups = explode('.', $file);
 $extension = end($groups);
 return strtolower($extension);
}

function trimleft($item, $chars)
{
 $arr = str_split($item);
 $num = sizeof($arr);
 for ($x=$chars; $x<$num; $x++)
  $trimed .= $arr[$x];
 return $trimed;
}

function trimright($item, $chars)
{
 $arr = str_split($item, 1);
 $num = sizeof($arr);
 for ($x=0; $x<($num-$chars); $x++)
  $trimed .= $arr[$x];
 return $trimed;
}

if (!function_exists('str_split'))
{
function str_split($chaine, $length=1)
{ 
 $retour = FALSE;
 $incrmt= (int)$length;
 if (0 < $incrmt)
 {
  $retour= array();
  $offset= 0;
  $limite= strlen($chaine);
  while ($offset < $limite)
  {
   $retour[]= substr($chaine, $offset, $incrmt);
   $offset += $incrmt;
  }
 }// if (0 < $incrmt)
 return ($retour);
}
}

function fileread($filename)
{ 
 return file_get_contents($filename);
}

function templateextract($template, $stringbegin, $stringend)
{
 $start = strpos($template, $stringbegin); // get beginning position
 $stop = strpos($template, $stringend); // get end position
 $length = $stop - $start; // calculate length
 $subtemplate = substr($template, $start, $length); // carve out what we want
 return $subtemplate;
}

function yesno($selected)
{
 global $languagegroup;
 $language = new language($languagegroup);
 if (($selected == 'no') || ($selected == '0'))
 {
  $stuff = "<option value='yes'>". $language->yes ."</option><option value='no' selected>". $language->no ."</option>";
 }
 else
 {
  $stuff = "<option value='yes' selected>". $language->yes ."</option><option value='no'>". $language->no ."</option>";
 }
 return $stuff;
}

function encodeit($item)
{
 $item = str_replace("'", "&#39;", $item);
 $item = str_replace('"', '&#34;', $item);
 $item = str_replace('<', '&lt;', $item);
 $item = str_replace('>', '&gt;', $item);
 return $item;
}

function decodeit($item)
{
 $item = str_replace('&#59;', ';', $item);
 $item = str_replace('&#125;', '}', $item);
 $item = str_replace('&#123;', '{', $item);
 $item = str_replace('&gt;', '>', $item); 
 $item = str_replace('&lt;', '<', $item);
 $item = str_replace('&quot;', "\"", $item);  
 $item = str_replace('&amp;', '&', $item);
// $item = stripslashes($item);    
 $item = str_replace("&#39;", "'",$item);
 $item = str_replace('&#34;', '"', $item);
 $item = str_replace("&#8242;", "'", $item);
 return $item;
}

function decodelite($item)
{
 $item = str_replace('&#59;', ';', $item);
 $item = str_replace('&#125;', '}', $item);
 $item = str_replace('&#123;', '{', $item);
 $item = str_replace('&gt;', '>', $item); 
 $item = str_replace('&lt;', '<', $item);
 $item = str_replace('&quot;', '"', $item);  
 $item = str_replace('&amp;', '&', $item);
 $item = str_replace("&#39;", "'",$item);
 $item = str_replace('&#34;', '"', $item);
 $item = str_replace("&#8242;", "'", $item);
 return $item;
}

function generalreplacements($totalpage)
{
 // in case there's anything left, replace all templatevarized GET and POST and COOKIE vars with the code-stripped values
 while(list($key, $value) = each($_REQUEST)) 
 {
  $tempvar = '{'. strtoupper($key) .'}';
  $totalpage = str_replace($tempvar, stripcode($value), $totalpage); 
 } 
 return $totalpage;
}

function sendemail($to, $subject, $message, $from)
{
 global $debug;
 if (($debug > 0) && ($debug < 4)) echo "<p>Sending e-mail titled $subject to $to , $from. Contents: $message";
 mail($to, $subject, $message, $from);
 return true;
}

function stripall($message)
{ // for spots where it shouldn't be left up to the setting
 $message = str_replace('<', '&#60;', $message);
 $message = str_replace('>', '&#62;', $message);
 $message = str_replace('&lt;', '&#60;', $message);
 $message = str_replace('&gt;', '&#62;', $message);
 return $message;
}

function stripcode($message)
{ // protection: don't allow user-posted php to execute
 global $settings;
 $message = str_replace('<?', '&#60;?', $message);
 $message = str_replace('?>', '?&#62;', $message);
 $message = str_replace('&lt;?', '&#60;?', $message);
 $message = str_replace('?&gt;', '?&#62;', $message);
 if ($settings->allowhtml == 'no') 
 {
  $message = str_replace('<', '&#60;', $message);
  $message = str_replace('>', '&#62;', $message);
  $message = str_replace('&lt;', '&#60;', $message);
  $message = str_replace('&gt;', '&#62;', $message);
 }
 return $message;
}

function finaloutput($phpDocument)
{
 $questMark = "?";
 $phpOpenTag = "<${questMark}php";
 $phpCloseTag = "${questMark}>";

 return eval("$phpCloseTag" . stripslashes($phpDocument) . "$phpOpenTag ");
}

function makeselection($stuff, $selection)
{
 $stuff = decodeit($stuff);
 $num = sizeof(explode('|||', $selection));
 if ($num < 2)
 {
   $final = str_replace('value="'.$selection .'"', 'value="'. $selection .'" selected', $stuff);
 }
 else
 {
  $selection = explode('|||', $selection);
  $final = $stuff;
  for ($count=0; $count<$num; $count++) 
  { 
   $thevalue = $selection[$count];
   $final = str_replace('value="'. $thevalue .'">', 'value="'. $thevalue .'" selected>', $final);
  }
 }
 return $final;
}

function langoptions($selected)
{
 global $settings;
 $languages = explode(',', $settings->languages);
 $num = sizeof($languages);
 for ($q=0; $q<$num; $q++)
 {
  if ($languages[$q] == $selected) $langoptions .= '<option value="'. $languages[$q] .'" selected>'. $languages[$q] .'</option>';
  else $langoptions .= '<option value="'. $languages[$q] .'">'. $languages[$q] .'</option>';
 }
 return $langoptions;
}

function tempoptions($selected)
{
 global $settings;
 $temparray = explode(',', $settings->templates);
 $num = sizeof($temparray);
 for ($x=0; $x<$num; $x++)
 {
  $thedir = str_replace('templates/', '', $temparray[$x]);
  if ($temparray[$x] == $selected) $tempoptions .= "<option value='$temparray[$x]' selected>$thedir</option>";
  else $tempoptions .= "<option value='$temparray[$x]'>$thedir</option>";	 
 }
 return $tempoptions;
}
?>